#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>

int mkdirs(const char *path, mode_t mode)
{
    char tmp_path[1024];
    const char *tmp = path;
    int  len  = 0;
    int  ret;

    if(path == NULL || strlen(path) >= 1024) {
        return -1;
    }

    /* 
    * 상위 디렉토리가 존재하는 지 검사하여, 미존재 시에  상위 디렉토리를 생성함
    */
    while((tmp = strchr(tmp, '/')) != NULL) {
        len = tmp - path;
        tmp++;
        
        if(len == 0) {
            continue;
        }

        strncpy(tmp_path, path, len);
        tmp_path[len] = 0x00;

        if((ret = mkdir(tmp_path, mode)) == -1) {
            if(errno != EEXIST) {
                return -1;
            }
        }
    }

    if(mkdir(path, mode) == -1) {
        if(errno != EEXIST) {
            return -1;
        }
    }
    return 0;
}